package no.stud.bolts;

import java.util.Map;
import backtype.storm.task.TopologyContext;
import backtype.storm.topology.BasicOutputCollector;
import backtype.storm.topology.OutputFieldsDeclarer;
import backtype.storm.topology.base.BaseBasicBolt;
import backtype.storm.tuple.Fields;
import backtype.storm.tuple.Tuple;
import backtype.storm.tuple.Values;

import no.stud.util.PointCompare;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;



public class IncrForwardSkylineBolt extends BaseBasicBolt {

// 	Integer id;	//  getThisTaskId, unique number
// 	String name;	// getThisComponentId, bolt type
	ArrayList<Double[]> skyList, remList;
	
	/**
	 */
	@Override
	public void cleanup() {
//  		System.out.println("we are done.");
	}

	/**
	 * On create 
	 */
	@Override
	public void prepare(Map stormConf, TopologyContext context) {
// 		this.name = context.getThisComponentId();		//
// 		this.id = context.getThisTaskId();		// 
		skyList = new ArrayList<Double[]>();		// A ArrayList to hold the skyline.
 		System.out.println("prepare() is ran.");		// Debug output to show that bolt is initialized.
		
	}

	@Override
	public void declareOutputFields(OutputFieldsDeclarer declarer) {
		declarer.declare(new Fields("multi-point"));
	}


	@Override
	public void execute(Tuple input, BasicOutputCollector collector) {
		//	Working serialization
		double[] in = (double[]) input.getValue(0);
 		if(in != null) if(in.length>0) {
 		
			// clean the remove list.
			remList = new ArrayList<Double[]>();
			
			// As we will do the comparation more times, save some overhead on converting to Double
			Double[] recivedPoint = new Double[in.length];
			for (int i=0; i<in.length; i++)
			{
				recivedPoint[i] = Double.valueOf(in[i]);
			}
			
		
			boolean dominated=false;
			outerloop:
			for(int x=0; x<skyList.size(); x++)
			{
				// if we are dominated, toss the point aka just return.
				if(PointCompare.isDominatedOfSimple(recivedPoint, skyList.get(x))){ 
					dominated = true;
					break outerloop;
				}
			
				// if we dominate one, add us to the list and add them to list of removal
				if(PointCompare.isDominatedOfSimple(skyList.get(x), recivedPoint))remList.add(skyList.get(x));
			}
			// if we got so far, no one dominated us, or skyline is empty.
		
		// remove the ones we dominated, if any.
		skyList.removeAll(remList);
		// add us self to the list. If we ain't dominated
		if(!dominated) {
			skyList.add(recivedPoint);
			collector.emit(new Values(in));
		}

		// dereference for gbc to be able to re claim memory
		remList=null;
		in = null;
//	 		System.out.println("Added point to skyline, to a total of "+skyList.size()+" points.");
		}
// 				throw new IllegalArgumentException("Forcing a shutdown of topology");	
	}
}
