package no.stud.spouts;
import java.util.Map;
import backtype.storm.spout.SpoutOutputCollector;
import backtype.storm.topology.OutputFieldsDeclarer;
import backtype.storm.topology.base.BaseRichSpout;
import backtype.storm.task.TopologyContext;
import backtype.storm.tuple.Fields;
import backtype.storm.tuple.Values;
import backtype.storm.utils.Utils;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;


/***
 * This Spout was used as a experiment, before moving on to the usage of a binary file format.
 * It might be slightly dated and may not work out of the box.
 * @author stormuser
 *
 */
public class FileReadSpout extends BaseRichSpout {

	private boolean completed = false;
	SpoutOutputCollector collector;		
	
	File file;
	FileReader fr;
	BufferedReader br;
	
	// Using a toggle to sleep every Xnd time.	
	int toggleSleepValue = 15;
	int toggleCount = 0;

	
	/*If reliability is on, and we get a ack. Remove it from send queue.*/
	public void ack(Object msgId) {
// 		System.out.println("OK:"+msgId);
//		Action to remove from queue.
	}
	
	public void close() {
		try {
			br.close();
			br.close();
		} catch (IOException e) {
			e.printStackTrace();
		}	
	}
	
	public void fail(Object msgId) {
		System.out.println("FAIL:"+msgId);
	}

	
	/**
	 * The only thing that the methods will do It is emit each generated random until limit reached 
	 */
	public void nextTuple() {
		// Short: Avoid deadloop, filling the buffers and crashing.
		//
		// Without sleep, would we always have work until buffers are full.
		// That causes also deadloop resource starvation in addition to 
		// communication breakdown in ZMQ, in random spouts\bolts that tries
		// to communicate with it causing random crashes.
		if(++toggleCount >= toggleSleepValue) {
			Utils.sleep(1);
			toggleCount = 0;
		}

		if(completed){
			Utils.sleep(10);	// Keep a low value, we still wanna be able to ack and replay, if failed.
		} else {
			try {
				br.readLine();
				this.collector.emit( /*broadcastToStreamId,*/ new Values());
				
			} catch (IOException e) {
				completed=true;
				e.printStackTrace();
			}	
		}
	}

	/**
	 * Init the spout, create the CorrelatedGenerator and get the collector object
	 */
	public void open(Map conf, TopologyContext context, SpoutOutputCollector collector) {
// 		this.gc = new CorrelatedGenerator(10000,15); // (range zero to iMaximum_value) , iNumberOfDimensions
		this.collector = collector;
		
		try {
			File file = new File("/tmp/storm-output.txt");
			// if file doesnt exists, then create it
			if (!file.exists()) {
				throw new IllegalArgumentException("Forcing a shutdown of topology, input din't exist.");
			} 
			fr = new FileReader(file.getAbsoluteFile());
			br = new BufferedReader(fr);
		} catch (IOException e) {
			completed=true;
			e.printStackTrace();
		}
	}

	/**
	 * Declare the output field(s) ""
	 */
	public void declareOutputFields(OutputFieldsDeclarer declarer) {
		declarer.declare(new Fields("multi-point"));
	}
}
