package no.stud.spouts.datagenerators;

import java.util.Random;

public class AntiCorrelatedGenerator extends DistributionGenerator{


	private Random normal;
	public double CUT=0.0;
	
	public AntiCorrelatedGenerator( int nMaxValue, int dimensions)
	{
        super(  nMaxValue,  dimensions);
		normal = new Random();
	}


	public double[] nextPoint ()
	{
		double sigma = 0.005; //Tao uses 0.005
		double mean = 0.5;
		double dims[] = new double[dimensions];
		double a = normal.nextGaussian()*sigma+mean;
		double sum  =0 ;
		for (int s=0;s<dimensions-1;s++)
		{
			dims [s] = uniform.nextDouble();
			sum = sum +dims [s];
		}	 
		dims[dimensions-1] = dimensions*a - sum; 
		boolean valid = true;
		boolean bCut = false;
		for (int s=0;s<dimensions;s++)
		{
			dims[s]=MAX_VALUE*dims[s];
			if ((dims[s]>MAX_VALUE)||(dims[s]<0)) valid=false;
			if (dims[s]>=CUT) bCut=true;
		}
		if (valid && bCut)
			return dims;
		else
			return nextPoint();
	}

}
