package no.stud.spouts.datagenerators;

import java.util.Random;

public class CorrelatedGenerator extends DistributionGenerator{


	private Random normal;
	public double CUT=0.0;

	public CorrelatedGenerator(int nMaxValue, int dimensions)
	{
        super( nMaxValue,  dimensions);
		normal = new Random();
	}


	public double[] nextPoint ()
	{
		double dims[] = new double[dimensions];
		double sigma1 = 0.15;
		double sigma2 = 0.05;
		double mean = 0.5;
		double a = normal.nextGaussian()*sigma1+mean;
		double sum  =0 ;
		
		for (int s=0;s<dimensions-1;s++)
		{
			dims [s] = normal.nextGaussian()*sigma2+a;
			sum = sum +dims [s];
		}	
	
		dims[dimensions-1] = dimensions*a-sum;
		boolean valid = true;
		boolean bCut = false;
	 	for (int s=0;s<dimensions;s++)
		 {
		 	dims[s]=MAX_VALUE*dims[s];
		 	if ((dims[s]>MAX_VALUE)||(dims[s]<0)) valid=false;
		 	if (dims[s]>=CUT) bCut=true;
		 }
		 if (valid && bCut) 
			return dims;
		  else
		 	return nextPoint();
	}
 
}
