package no.stud.spouts.datagenerators;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Random;

public abstract class DistributionGenerator {

	protected int MAX_VALUE;
	protected Random uniform;
	protected int dimensions;

	/**
	*	Constructor function to set basics.
	*/

	public DistributionGenerator( int nMaxValue, int dimensions)
	{
		this.MAX_VALUE = nMaxValue-1;	//why -1?
		uniform = new Random();
		this.dimensions = dimensions;
	}


	public abstract double[] nextPoint ();

	/**
	*	Double toString() help function as point is a normal double array.
	*/
	public String doubleAtoString(double[] point) {
		String line = "";
		for (double dimension:point) {
			line = line+" "+dimension;
		}
		return line;
	}
	
	/**
	*	Function to get and return one generated point as string.
	*	DEPRECATED
	*/
	@Deprecated
	public String getNextPointAsString()
	{
		return doubleAtoString(nextPoint());
	}
	
}
