package no.stud.util;

public enum DistributionType {
	ANTICORRELATED(0),
	CORRELATED(1),
	UNIFORM(2);
	
	private final Integer id;
	
	// Constructor to set the final int for all the listed enums.
	DistributionType(int id){
		this.id = id;
	}
	
	/**
	*	Return the assigned id.
	*/	
	public Integer getId(){return id;}
	
	
	/**
	*	Function to be able to map ENUM (integers) from our config back to enums.
	*	Can be improved with a static hashmap.
	*/
	public static DistributionType toType(int id) {
		for (DistributionType dt : DistributionType.values()) {
			if (dt.getId() == id) {
				return dt;
			}
		}
	return null;
	}
}