package no.stud.util;

public class PointCompare {

	/**
	 * Simple compare, lower value is better. Returns true if pointCompared is dominated of otherPoint
	 */
	public static boolean isDominatedOfSimple(Double[] pointCompared, Double[] otherPoint) {
		// for alle dimensjoner i begge point
		boolean isAtLeastBetterInOneDimension = false;
		for ( int currentPos=0; currentPos < otherPoint.length; currentPos++) {
			//
			if(pointCompared[currentPos] < otherPoint[currentPos]) return false;
			if(pointCompared[currentPos] > otherPoint[currentPos]) isAtLeastBetterInOneDimension=true;
			// if point is equal do nothing, can't decide on it.
				
		}
		// checked all dimensions, all dimensions was at least as good.
		// Need to check that one dimension is better to conclude
		// true. Optimized the check away and just return the
		// flag as it is identical with what we look after and return.
				
		return isAtLeastBetterInOneDimension;
	}

	/***
	 * Advanced compare, takes a array of signs to indicate what is better, lower or higher value. 
	 */
	public static boolean isDominatedOfAdvanced(Double[] pointCompared, Double[] otherPoint, char[] bestValueIndicator) {
		boolean isAtLeastBetterInOneDimension = false;
		for ( int currentPos=0; currentPos < otherPoint.length; currentPos++) {
			// check the bestValueIndicator and do the correct action.
			// a minus '-' indicates lower is better, and anything else indicates 
			// higher is better.
			if(bestValueIndicator[currentPos] == '-') {
				if(pointCompared[currentPos] < otherPoint[currentPos]) return false;
				if(pointCompared[currentPos] > otherPoint[currentPos]) isAtLeastBetterInOneDimension=true;
			} else {
				if(pointCompared[currentPos] > otherPoint[currentPos]) return false;
				if(pointCompared[currentPos] < otherPoint[currentPos]) isAtLeastBetterInOneDimension=true;
			}
		}
		// checked all dimensions, all dimensions was at least as good.
		// Need to check that one dimension is better to conclude
		// true. Optimized the check away and just return the
		// flag as it is identical with what we look after and return.
				
		return isAtLeastBetterInOneDimension;
	}
	
}


// TODO:: remove dead code/comments
/*
public class pointComp implements Comparator<Object> {

	@Override
	public int compare(Object arg0, Object arg1) {
		// TODO Auto-generated method stub
		return 0;
	}
	
}*/